/*
 * Aipo is a groupware program developed by Aimluck,Inc.
 * Copyright (C) 2004-2008 Aimluck,Inc.
 * http://aipostyle.com/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.aimluck.eip.hanyo.util;


import java.util.List;


import org.apache.cayenne.access.DataContext;
import org.apache.cayenne.exp.Expression;
import org.apache.cayenne.exp.ExpressionFactory;

import org.apache.cayenne.query.SelectQuery;

import org.apache.jetspeed.services.logging.JetspeedLogFactoryService;
import org.apache.jetspeed.services.logging.JetspeedLogger;

import org.apache.turbine.util.RunData;
import org.apache.velocity.context.Context;

import com.aimluck.eip.cayenne.om.portlet.ImwMHanyo;
import com.aimluck.eip.common.ALEipConstants;
import com.aimluck.eip.orm.DatabaseOrmService;
import com.aimluck.eip.util.ALEipUtils;

/**
 * 汎用マスタのユーティリティクラスです
 */
public class HanyoUtils {

  /** logger */
  private static final JetspeedLogger logger = JetspeedLogFactoryService
      .getLogger(HanyoUtils.class.getName());

  public static ImwMHanyo getImwMHanyo(RunData rundata, Context context) {
    ImwMHanyo result = null;
    String id = ALEipUtils.getTemp(rundata, context, ALEipConstants.ENTITY_ID);
    try {
      if (id == null || Integer.valueOf(id) == null) {
        logger.debug("Empty ID...");
        return result;
      }

      DataContext dataContext = DatabaseOrmService.getInstance()
          .getDataContext();
      Expression exp = ExpressionFactory.matchDbExp(
          ImwMHanyo.HANYO_ID_PK_COLUMN, Integer.valueOf(id));
      SelectQuery query = new SelectQuery(ImwMHanyo.class, exp);
      List list = dataContext.performQuery(query);
      if (list == null || list.size() == 0) {
        logger.debug("Not found ID...");
        return result;
      }
      result = (ImwMHanyo) list.get(0);
    } catch (Exception ex) {
      logger.error("Exception", ex);
    }
    return result;
  }

  public static List getHanyoList() {

    DataContext dataContext = DatabaseOrmService.getInstance().getDataContext();

    Expression exp = ExpressionFactory.matchExp(
        ImwMHanyo.PARENT_HANYO_ID_PROPERTY, null);
    SelectQuery query = new SelectQuery(ImwMHanyo.class, exp);

    List list = dataContext.performQuery(query);

    int registeredUserNum = list.size();

    if (registeredUserNum == 0) {
      return null;
    }
    return list;
  }

  public static String getParentHanyoName(Integer parentHanyoId) {
    DataContext dataContext = DatabaseOrmService.getInstance().getDataContext();
    Expression exp = ExpressionFactory.matchDbExp(ImwMHanyo.HANYO_ID_PK_COLUMN,
        parentHanyoId);
    SelectQuery query = new SelectQuery(ImwMHanyo.class, exp);
    List list = dataContext.performQuery(query);
    if (list == null || list.size() == 0) {
      return "";
    }
    ImwMHanyo result = (ImwMHanyo) list.get(0);

    return result.getHanyokubunnm();
  }
}
